program DropBackup;

{$APPTYPE CONSOLE}

{$R 'version.res' 'version.rc'}

uses
  Windows,
  SysUtils,
  ShellApi;

//-----------------------------------------------------------------------------
//  Subject: [Delphi:57980] Re: fBNgȉ̃t@CăRs[
function SHCopyDir(const AHWND: HWND; const AFrom, ATo: String): Boolean;
var
    LSFO: TSHFileOpStruct;
    LFrom: String;
    LTo: String;
begin
    LFrom := AFrom + #0#0;
    LTo := ATo + #0#0;

    FillChar(LSFO, 0, SizeOf(LSFO));
    LSFO.Wnd := AHWND;
    LSFO.wFunc := FO_COPY;
    LSFO.pFrom := PChar(LFrom);
    LSFO.pTo := PChar(LTo);
    LSFO.fFlags := FOF_ALLOWUNDO or FOF_NOCONFIRMMKDIR or FOF_RENAMEONCOLLISION;
    LSFO.fAnyOperationsAborted := True;
    LSFO.hNameMappings := nil;

    Result := not Boolean(SHFileOperation(LSFO));
end;

//-----------------------------------------------------------------------------
//  t+AԂłȂO
function GetNewPath(const ABasePath, ACurrName: String): String;
var
    LCurrName: String;
    LDate: String;
    LPreFix: String;
    i: Integer;
begin
    LCurrName := ExcludeTrailingPathDelimiter(ACurrName);
    LDate := FormatDateTime('YYYYMMDD', Now()) + '_';
    LPreFix := LDate;
    Result := IncludeTrailingPathDelimiter(ABasePath) + LPreFix + LCurrName;

    i := 0;
    while (FileExists(Result)) or (DirectoryExists(Result)) do
    begin
        Inc(i);
        LPreFix := LDate + IntToHex(i, 1) + '_';
        Result := IncludeTrailingPathDelimiter(ABasePath) + LPreFix + LCurrName;
    end;
end;

//-----------------------------------------------------------------------------
var
    i: Integer;
    LPath: String;
    LBase: String;
    LName: String;
    LNewPath: String;
begin
    for i := 1 to ParamCount do
    begin
        LPath := ParamStr(i);
        if (FileExists(LPath)) then
        begin
            LBase := ExtractFilePath(LPath);
            LName := ExtractFileName(LPath);
            LNewPath := GetNewPath(LBase, LName);
        end
        else
        if (DirectoryExists(LPath)) then
        begin
            LPath := ExcludeTrailingPathDelimiter(ParamStr(i));
            LBase := ExtractFilePath(LPath);
            LName := ExtractFileName(LPath);
            LNewPath := GetNewPath(LBase, LName);
            LNewPath := IncludeTrailingPathDelimiter(LNewPath);
        end
        else
        begin
            Continue;
        end;
        SHCopyDir(0, LPath, LNewPath);
    end;
end.
